package com.systemj;

import java.util.ArrayList;
import java.util.HashMap;

import systemj.interfaces.Parser;

import android.content.Context;
import android.content.res.Resources;
import android.content.res.XmlResourceParser;

public class AndroidParser implements Parser
{
	public ArrayList<HashMap<String, String>> getData()
	{
		return data;
	}

	public void parse() throws RuntimeException
	{
		Resources r = context.getResources();
		XmlResourceParser parser = r.getXml(xmlref);
		data = new ArrayList<HashMap<String,String>>();
		
		try
		{
			int eventType = parser.getEventType();
			boolean done = false;
			boolean input = true;
			while (eventType != XmlResourceParser.END_DOCUMENT && !done)
			{
				String name;
				switch(eventType)
				{
					case XmlResourceParser.START_TAG:
						name = parser.getName();
						if(name.equalsIgnoreCase("INPUTS"))
						{
							input = true;
							System.out.println("in input section");
						}
						if(name.equalsIgnoreCase("OUTPUTS"))
						{
							input = false;
							System.out.println("in output section");
						}
						if(name.equalsIgnoreCase("SIGNAL"))
						{
							HashMap<String,String> atts = new HashMap<String,String>();
							for(int i = 0; i < parser.getAttributeCount(); i++)
							{
								atts.put(parser.getAttributeName(i), parser.getAttributeValue(i));
							}
							data.add(atts);
						}
						if(name.equalsIgnoreCase("CHANNEL"))
						{
							HashMap<String,String> atts = new HashMap<String,String>();
							for(int i = 0; i < parser.getAttributeCount(); i++)
							{
								if(parser.getAttributeName(i).equalsIgnoreCase("NAME"))
								{
									String n;
									if(input)
									{
										n = parser.getAttributeValue(i) + "_in";
									}
									else
									{
										n = parser.getAttributeValue(i) + "_inp";
									}
									atts.put(parser.getAttributeName(i), n);
								}
								else
								{
									atts.put(parser.getAttributeName(i), parser.getAttributeValue(i));
								}
							}
							data.add(atts);
							HashMap<String,String> atts2 = new HashMap<String,String>();
							for(int i = 0; i < parser.getAttributeCount(); i++)
							{
								if(parser.getAttributeName(i).equalsIgnoreCase("NAME"))
								{
									String n;
									if(input)
									{
										n = parser.getAttributeValue(i) + "_op";
									}
									else
									{
										n = parser.getAttributeValue(i) + "_o";
									}
									atts2.put(parser.getAttributeName(i), n);
								}
								else
								{
									atts2.put(parser.getAttributeName(i), parser.getAttributeValue(i));
								}
							}
							data.add(atts2);
						}
						break;
					case XmlResourceParser.END_TAG:
						name = parser.getName();
						if(name.equalsIgnoreCase("SYSTEMJPROGRAM"))
						{
							done = true;
						}
						break;
				}
				eventType = parser.next();
			}
		}
		catch (Exception e)
		{
			Log.e("SystemJRuntime", "Error parsing signal XML", e);
		}
	}

	public void setTarget(Object target, Object context) throws RuntimeException
	{
		xmlref = (Integer)target;
		this.context = (Context)context;
	}
	
	private int xmlref = -1;
	private Context context;
	private ArrayList<HashMap<String, String>> data = null;
	private AndroidIOLogger Log = new AndroidIOLogger();
}
