package com.systemj;

import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.util.Log;
import java.util.UUID;
import java.io.IOException;

public class BluetoothConnectThread extends Thread
{
	public BluetoothConnectThread(BluetoothDevice device, SystemJService serv)
	{
		service = Android.getSystemJService();
	
		BluetoothSocket tmp = null;
		Log.i("Bluetooth Test", "UUID: " + MY_UUID);
		
		try
		{
			tmp = device.createRfcommSocketToServiceRecord(MY_UUID);
		}
		catch(IOException e)
		{
			Log.e("Bluetooth Test", "Error creating socket", e);
		}
		
		socket = tmp;
	}
	
	public void run()
	{
		while(connected == null)
		{
			try
			{
				Log.i("Bluetooth Test", "Connecting...");
				socket.connect();
				Log.i("Bluetooth Test", "Connected!");
				Android.getBluetoothActivity().showLogin();
				
				connected = new BluetoothConnectedThread(socket);
				connected.start();
			}
			catch(IOException e0)
			{
				Log.e("Bluetooth Test", "Unable to initiate connection", e0);
				Android.getBluetoothActivity().showError("Unable to initiate bluetooth connection. Will retry in 10 seconds.", false);
				try
				{
					Thread.sleep(10000);
				}
				catch(Exception e1)
				{}
			}
		}
		
		while(Android.getSystemJService() == null) {}
		Android.getSystemJService().handleEvent("onConnect", connected);
	}
	
	public void cancel()
	{
		try
		{
			socket.close();
		}
		catch(IOException e1)
		{}
	}
	
	private final BluetoothSocket socket;
	private BluetoothConnectedThread connected;
	private SystemJService service;
	
	private final UUID MY_UUID = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");
}
