package com.systemj;

import android.bluetooth.BluetoothSocket;
import android.util.Log;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;

public class BluetoothConnectedThread extends Thread
{
	public BluetoothConnectedThread(BluetoothSocket s)
	{
		socket = s;
		
		InputStream tmpIn = null;
		OutputStream tmpOut = null;
	
		try
		{
			tmpIn = socket.getInputStream();
			tmpOut = socket.getOutputStream();
		}
		catch(IOException e)
		{
			Log.e("Bluetooth Test", "IOException", e);
		}
	
		in = tmpIn;
		out = tmpOut;
	}
	
	public void run()
	{
		byte[] tmp = new byte[1024];
		int b;
		
		while(true)
		{
			try
			{
				b = in.read(tmp);
				if(b > 0)
				{
					buffer = tmp;
					bytes = b;
					Log.i("Bluetooth Test", "Read " + bytes + " bytes");
					//Log.i("Bluetooth Test", new String(buffer));
				}
			}
			catch(IOException e)
			{
				Log.e("Bluetooth Test", "Can't read from server! Assuming connection lost.", e);
				Android.getBluetoothActivity().showError("Connection to server lost!", true);
				return;
			}
		}
	}
	
	public synchronized void write(byte[] buf)
	{
		try
		{
			out.write(buf);
			Log.i("Bluetooth Test", "Sent: " + new String(buf));
		}
		catch(IOException e)
		{
			Log.e("Bluetooth Test", "Unable to send data", e);
			Android.getBluetoothActivity().showError("Connection to server lost!", true);
		}
	}
	
	public synchronized byte[] getBuffer()
	{
		byte[] tmp = buffer;
		return tmp;
	}
	
	public synchronized void clearBuffer()
	{
		buffer = new byte[1];
		bytes = 0;
	}
	
	public synchronized int getBufferSize()
	{
		return bytes;
	}
	
	public void cancel()
	{
		try
		{
			socket.close();
		}
		catch(IOException e)
		{}
	}
	
	private final BluetoothSocket socket;
	private final InputStream in;
	private final OutputStream out;
	
	private byte[] buffer = new byte[1];
	private int bytes = 0;
}
